local TinyFrapsReminder = CreateFrame("Frame", "TinyFrapsReminder");
ReadyCheckList = {};
NextCheck = nil;

-- Binding Variables
BINDING_HEADER_TFR = "TinyFrapsReminder";
BINDING_NAME_STARTSTOP = "Recording Toggle keybind:";

StaticPopupDialogs["TinyFrapsReminder_start"] = {
  text = "Ready Check Completed, Start recording now.",
  button1 = "Okay, Go away.",
  timeout = 0,
  whileDead = true,
  hideOnEscape = true,
}

StaticPopupDialogs["TinyFrapsReminder_BG"] = {
  text = "PvP combat begins in 15 seconds, Start recording now.",
  button1 = "Okay, Go away.",
  timeout = 0,
  whileDead = true,
  hideOnEscape = true,
}

StaticPopupDialogs["TinyFrapsReminder_stop"] = {
  text = "Now would be a good time to stop recording.",
  button1 = "Got it.",
  timeout = 0,
  whileDead = true,
  hideOnEscape = true,
}

function TFR_StartStop()

	StaticPopup_Hide ("TinyFrapsReminder_start");
	StaticPopup_Hide ("TinyFrapsReminder_BG");
	StaticPopup_Hide ("TinyFrapsReminder_stop");

end

function TFR_CombatCheck(self)
	
	local combat = false;
	local raidmembers = GetNumRaidMembers();
	
	for i = 1, raidmembers do
		local unitname = GetRaidRosterInfo(i);
		if ( unitname ) then
			if ( UnitAffectingCombat(unitname) ) then
				combat = true;
			end
		end
	end
	
	if ( combat == false ) then
		StaticPopup_Show ("TinyFrapsReminder_stop");
		NextCheck = nil;
		TinyFrapsReminder:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
	end
	
end

function TFR_OnEvent(self, event, ...)
	if ( event == "READY_CHECK_FINISHED" ) then
		StaticPopup_Show ("TinyFrapsReminder_start");
		TinyFrapsReminder:UnregisterEvent("READY_CHECK_FINISHED");
		TinyFrapsReminder:UnregisterEvent("READY_CHECK_CONFIRM");
		TinyFrapsReminder:RegisterEvent("PLAYER_REGEN_DISABLED");
	elseif ( event == "READY_CHECK" ) then
		if	( UnitInRaid("player") ) then
			if ( IsRaidOfficer() or IsRaidLeader() ) then
				TinyFrapsReminder:RegisterEvent("READY_CHECK_CONFIRM");
				wipe(ReadyCheckList);
				-- ChatFrame1:AddMessage( select(1, ...) .. " started a Ready Check", .9, 0, .9); -- debug
				for i = 1, GetNumRaidMembers() do
					local charname, _ = UnitName("raid"..i);
					tinsert(ReadyCheckList, charname);
					if ( charname == select(1, ...) ) then
						tinsert(ReadyCheckList, true);
						-- ChatFrame1:AddMessage( charname .. " set to true" , .9, 0, .9); -- debug
					else
						tinsert(ReadyCheckList, "NO");
						-- ChatFrame1:AddMessage( charname .. " set to NO" , .9, 0, .9); -- debug
					end
				end
			else
				TinyFrapsReminder:RegisterEvent("READY_CHECK_FINISHED");
			end
		end
	elseif ( event == "READY_CHECK_CONFIRM" ) then
		if select(2, ...) then
			readyornot = "Ready."
			local charname, _ = UnitName(select(1, ...));
			local i = 1;
			while ReadyCheckList[i] do
				if ( ReadyCheckList[i] == charname ) then
					ReadyCheckList[i+1] = true;
				end
				i = i + 1;
			end
		else
			readyornot = "Not Ready."
		end
		-- ChatFrame1:AddMessage( select(1, ...) .. " is " .. readyornot , .9, 0, .9); -- debug
		if ( tContains(ReadyCheckList, "NO") ) then
			-- ChatFrame1:AddMessage( "'NO' is there" , .9, 0, .9); -- debug
		else
			TinyFrapsReminder:RegisterEvent("READY_CHECK_FINISHED");
		end
	elseif	( event == "COMBAT_LOG_EVENT_UNFILTERED" ) then
		if (( NextCheck == nil ) or ( NextCheck <= time() )) then
			NextCheck = time() + 2;
			TFR_CombatCheck(self);
		end
	elseif	( event == "PLAYER_REGEN_DISABLED" ) then
		TinyFrapsReminder:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
		TinyFrapsReminder:UnregisterEvent("PLAYER_REGEN_DISABLED");
	elseif	( event == "CHAT_MSG_BG_SYSTEM_NEUTRAL" ) then
		if string.match( ... , "15 seconds" ) or string.match( ... , "Fifteen seconds until" ) then
			StaticPopup_Show ("TinyFrapsReminder_BG");
			TinyFrapsReminder:RegisterEvent("PLAYER_REGEN_DISABLED");
		end
	end
end

TinyFrapsReminder:RegisterEvent("READY_CHECK");
TinyFrapsReminder:RegisterEvent("CHAT_MSG_BG_SYSTEM_NEUTRAL");

TinyFrapsReminder:SetScript("OnEvent", TFR_OnEvent);
